OpenVDB: PointIndexLeafNode< T, Log2Dim > Struct Template Reference

OpenVDB 3.1.0

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Member Functions | Static Public Attributes | Protected Types | Protected Member Functions | Static Protected Member Functions | Friends | List of all members
PointIndexLeafNode< T, Log2Dim > Struct Template Reference

`#include <PointIndexGrid.h>`

Inherits LeafNode< T, Log2Dim >.

## Public Types
typedef PointIndexLeafNode< T, Log2Dim > | LeafNodeType
typedef boost::shared_ptr< PointIndexLeafNode > | Ptr
typedef T | ValueType
typedef std::vector< ValueType > | IndexArray
typedef tree::LeafNode< T, Log2Dim > | BaseLeaf
typedef util::NodeMask< Log2Dim > | NodeMaskType
typedef BaseLeaf::template ValueIter< MaskOnIterator, PointIndexLeafNode, const ValueType, ValueOn > | ValueOnIter
typedef BaseLeaf::template ValueIter< MaskOnIterator, const PointIndexLeafNode, const ValueType, ValueOn > | ValueOnCIter
typedef BaseLeaf::template ValueIter< MaskOffIterator, PointIndexLeafNode, const ValueType, ValueOff > | ValueOffIter
typedef BaseLeaf::template ValueIter< MaskOffIterator, const PointIndexLeafNode, const ValueType, ValueOff > | ValueOffCIter
typedef BaseLeaf::template ValueIter< MaskDenseIterator, PointIndexLeafNode, const ValueType, ValueAll > | ValueAllIter
typedef BaseLeaf::template ValueIter< MaskDenseIterator, const PointIndexLeafNode, const ValueType, ValueAll > | ValueAllCIter
typedef BaseLeaf::template ChildIter< MaskOnIterator, PointIndexLeafNode, ChildOn > | ChildOnIter
typedef BaseLeaf::template ChildIter< MaskOnIterator, const PointIndexLeafNode, ChildOn > | ChildOnCIter
typedef BaseLeaf::template ChildIter< MaskOffIterator, PointIndexLeafNode, ChildOff > | ChildOffIter
typedef BaseLeaf::template ChildIter< MaskOffIterator, const PointIndexLeafNode, ChildOff > | ChildOffCIter
typedef BaseLeaf::template DenseIter< PointIndexLeafNode, ValueType, ChildAll > | ChildAllIter
typedef BaseLeaf::template DenseIter< const PointIndexLeafNode, const ValueType, ChildAll > | ChildAllCIter

## Public Member Functions
IndexArray & | indices ()
const IndexArray & | indices () const
bool | getIndices (const Coord &ijk, const ValueType *&begin, const ValueType *&end) const
bool | getIndices (Index offset, const ValueType *&begin, const ValueType *&end) const
void | setOffsetOn (Index offset, const ValueType &val)
void | setOffsetOnly (Index offset, const ValueType &val)
bool | isEmpty (const CoordBBox &bbox) const
| PointIndexLeafNode ()
| Default constructor. More...
| PointIndexLeafNode (const Coord &coords, const T &value=zeroVal< T >(), bool active=false)
| PointIndexLeafNode (PartialCreate, const Coord &coords, const T &value=zeroVal< T >(), bool active=false)
| PointIndexLeafNode (const PointIndexLeafNode &rhs)
| Deep copy constructor. More...
template<typename OtherType , Index OtherLog2Dim>
bool | hasSameTopology (const PointIndexLeafNode< OtherType, OtherLog2Dim > *other) const
| Return `true` if the given node (which may have a different `ValueType` than this node) has the same active value topology as this node. More...
bool | operator== (const PointIndexLeafNode &other) const
| Check for buffer, state and origin equivalence. More...
bool | operator!= (const PointIndexLeafNode &other) const
template<MergePolicy Policy>
void | merge (const PointIndexLeafNode &rhs)
template<MergePolicy Policy>
void | merge (const ValueType &tileValue, bool tileActive)
template<MergePolicy Policy>
void | merge (const PointIndexLeafNode &other, const ValueType &, const ValueType &)
void | addLeaf (PointIndexLeafNode *)
template<typename AccessorT >
void | addLeafAndCache (PointIndexLeafNode *, AccessorT &)
void | readBuffers (std::istream &is, bool fromHalf=false)
void | readBuffers (std::istream &is, const CoordBBox &, bool fromHalf=false)
void | writeBuffers (std::ostream &os, bool toHalf=false) const
Index64 | memUsage () const
void | assertNonmodifiable ()
void | setActiveState (const Coord &, bool)
void | setActiveState (Index, bool)
void | setValueOnly (const Coord &, const ValueType &)
void | setValueOnly (Index, const ValueType &)
void | setValueOff (const Coord &)
void | setValueOff (Index)
void | setValueOff (const Coord &, const ValueType &)
void | setValueOff (Index, const ValueType &)
void | setValueOn (const Coord &)
void | setValueOn (Index)
void | setValueOn (const Coord &, const ValueType &)
void | setValueOn (Index, const ValueType &)
void | setValue (const Coord &, const ValueType &)
void | setValuesOn ()
void | setValuesOff ()
template<typename ModifyOp >
void | modifyValue (Index, const ModifyOp &)
template<typename ModifyOp >
void | modifyValue (const Coord &, const ModifyOp &)
template<typename ModifyOp >
void | modifyValueAndActiveState (const Coord &, const ModifyOp &)
void | clip (const CoordBBox &, const ValueType &)
void | fill (const CoordBBox &, const ValueType &, bool)
void | fill (const ValueType &)
void | fill (const ValueType &, bool)
template<typename AccessorT >
void | setValueOnlyAndCache (const Coord &, const ValueType &, AccessorT &)
template<typename ModifyOp , typename AccessorT >
void | modifyValueAndActiveStateAndCache (const Coord &, const ModifyOp &, AccessorT &)
template<typename AccessorT >
void | setValueOffAndCache (const Coord &, const ValueType &, AccessorT &)
template<typename AccessorT >
void | setActiveStateAndCache (const Coord &, bool, AccessorT &)
void | resetBackground (const ValueType &, const ValueType &)
void | signedFloodFill (const ValueType &)
void | signedFloodFill (const ValueType &, const ValueType &)
void | negate ()
ValueOnCIter | cbeginValueOn () const
ValueOnCIter | beginValueOn () const
ValueOnIter | beginValueOn ()
ValueOffCIter | cbeginValueOff () const
ValueOffCIter | beginValueOff () const
ValueOffIter | beginValueOff ()
ValueAllCIter | cbeginValueAll () const
ValueAllCIter | beginValueAll () const
ValueAllIter | beginValueAll ()
ValueOnCIter | cendValueOn () const
ValueOnCIter | endValueOn () const
ValueOnIter | endValueOn ()
ValueOffCIter | cendValueOff () const
ValueOffCIter | endValueOff () const
ValueOffIter | endValueOff ()
ValueAllCIter | cendValueAll () const
ValueAllCIter | endValueAll () const
ValueAllIter | endValueAll ()
ChildOnCIter | cbeginChildOn () const
ChildOnCIter | beginChildOn () const
ChildOnIter | beginChildOn ()
ChildOffCIter | cbeginChildOff () const
ChildOffCIter | beginChildOff () const
ChildOffIter | beginChildOff ()
ChildAllCIter | cbeginChildAll () const
ChildAllCIter | beginChildAll () const
ChildAllIter | beginChildAll ()
ChildOnCIter | cendChildOn () const
ChildOnCIter | endChildOn () const
ChildOnIter | endChildOn ()
ChildOffCIter | cendChildOff () const
ChildOffCIter | endChildOff () const
ChildOffIter | endChildOff ()
ChildAllCIter | cendChildAll () const
ChildAllCIter | endChildAll () const
ChildAllIter | endChildAll ()
Index64 | onVoxelCount () const
| Return the number of voxels marked On. More...
Index64 | offVoxelCount () const
| Return the number of voxels marked Off. More...
Index64 | onLeafVoxelCount () const
Index64 | offLeafVoxelCount () const
bool | isEmpty () const
| Return `true` if this node has no active voxels. More...
bool | isDense () const
| Return `true` if this node contains only active voxels. More...
bool | isAllocated () const
| Return `true` if memory for this node's buffer has been allocated. More...
bool | allocate ()
| Allocate memory for this node's buffer if it has not already been allocated. More...
void | evalActiveBoundingBox (CoordBBox &bbox, bool visitVoxels=true) const
CoordBBox | getNodeBoundingBox () const
| Return the bounding box of this node, i.e., the full index space spanned by this leaf node. More...
void | setOrigin (const Coord &origin)
| Set the grid index coordinates of this node's local origin. More...
Coord | offsetToGlobalCoord (Index n) const
| Return the global coordinates for a linear table offset. More...
std::string | str () const
| Return a string representation of this node. More...
template<typename OtherType , Index OtherLog2Dim>
bool | hasSameTopology (const LeafNode< OtherType, OtherLog2Dim > *other) const
| Return `true` if the given node (which may have a different `ValueType` than this node) has the same active value topology as this node. More...
bool | operator== (const LeafNode &other) const
| Check for buffer, state and origin equivalence. More...
bool | operator!= (const LeafNode &other) const
void | swap (Buffer &other)
| Exchange this node's data buffer with the given data buffer without changing the active states of the values. More...
const Buffer & | buffer () const
Buffer & | buffer ()
void | readTopology (std::istream &is, bool fromHalf=false)
| Read in just the topology. More...
void | writeTopology (std::ostream &os, bool toHalf=false) const
| Write out just the topology. More...
size_t | streamingSize (bool toHalf=false) const
const ValueType & | getValue (const Coord &xyz) const
| Return the value of the voxel at the given coordinates. More...
const ValueType & | getValue (Index offset) const
| Return the value of the voxel at the given linear offset. More...
template<typename AccessorT >
const ValueType & | getValue (const Coord &xyz, bool &state, int &level, AccessorT &) const
| Return the value of the voxel at the given coordinates and return its active state and level (i.e., 0) in state and level. More...
bool | probeValue (const Coord &xyz, ValueType &val) const
| Return `true` if the voxel at the given coordinates is active. More...
bool | probeValue (Index offset, ValueType &val) const
| Return `true` if the voxel at the given offset is active. More...
bool | isValueOn (const Coord &xyz) const
| Return `true` if the voxel at the given coordinates is active. More...
bool | isValueOn (Index offset) const
| Return `true` if the voxel at the given offset is active. More...
template<typename DenseT >
void | copyToDense (const CoordBBox &bbox, DenseT &dense) const
| Copy into a dense grid the values of the voxels that lie within a given bounding box. More...
template<typename DenseT >
void | copyFromDense (const CoordBBox &bbox, const DenseT &dense, const ValueType &background, const ValueType &tolerance)
| Copy from a dense grid into this node the values of the voxels that lie within a given bounding box. More...
template<typename AccessorT >
const ValueType & | getValueAndCache (const Coord &xyz, AccessorT &) const
| Return the value of the voxel at the given coordinates. More...
template<typename AccessorT >
bool | isValueOnAndCache (const Coord &xyz, AccessorT &) const
| Return `true` if the voxel at the given coordinates is active. More...
template<typename AccessorT >
void | setValueAndCache (const Coord &xyz, const ValueType &val, AccessorT &)
| Change the value of the voxel at the given coordinates and mark it as active. More...
template<typename ModifyOp , typename AccessorT >
void | modifyValueAndCache (const Coord &xyz, const ModifyOp &op, AccessorT &)
| Apply a functor to the value of the voxel at the given coordinates and mark the voxel as active. More...
template<typename AccessorT >
bool | probeValueAndCache (const Coord &xyz, ValueType &val, AccessorT &) const
| Return `true` if the voxel at the given coordinates is active and return the voxel value in val. More...
const ValueType & | getFirstValue () const
| Return a const reference to the first value in the buffer. More...
const ValueType & | getLastValue () const
| Return a const reference to the last value in the buffer. More...
void | voxelizeActiveTiles ()
template<MergePolicy Policy>
void | merge (const LeafNode &)
template<MergePolicy Policy>
void | merge (const LeafNode &other, const ValueType &, const ValueType &)
template<typename OtherType >
void | topologyUnion (const LeafNode< OtherType, Log2Dim > &other)
| Union this node's set of active values with the active values of the other node, whose `ValueType` may be different. So a resulting voxel will be active if either of the original voxels were active. More...
template<typename OtherType >
void | topologyIntersection (const LeafNode< OtherType, Log2Dim > &other, const ValueType &)
| Intersect this node's set of active values with the active values of the other node, whose `ValueType` may be different. So a resulting voxel will be active only if both of the original voxels were active. More...
template<typename OtherType >
void | topologyDifference (const LeafNode< OtherType, Log2Dim > &other, const ValueType &)
| Difference this node's set of active values with the active values of the other node, whose `ValueType` may be different. So a resulting voxel will be active only if the original voxel is active in this LeafNode and inactive in the other LeafNode. More...
template<typename CombineOp >
void | combine (const LeafNode &other, CombineOp &op)
template<typename CombineOp >
void | combine (const ValueType &value, bool valueIsActive, CombineOp &op)
template<typename CombineOp , typename OtherType >
void | combine2 (const LeafNode &other, const OtherType &, bool valueIsActive, CombineOp &)
template<typename CombineOp , typename OtherNodeT >
void | combine2 (const ValueType &, const OtherNodeT &other, bool valueIsActive, CombineOp &)
template<typename CombineOp , typename OtherNodeT >
void | combine2 (const LeafNode &b0, const OtherNodeT &b1, CombineOp &)
template<typename BBoxOp >
void | visitActiveBBox (BBoxOp &) const
| Calls the templated functor BBoxOp with bounding box information. An additional level argument is provided to the callback. More...
template<typename VisitorOp >
void | visit (VisitorOp &)
template<typename VisitorOp >
void | visit (VisitorOp &) const
template<typename OtherLeafNodeType , typename VisitorOp >
void | visit2Node (OtherLeafNodeType &other, VisitorOp &)
template<typename OtherLeafNodeType , typename VisitorOp >
void | visit2Node (OtherLeafNodeType &other, VisitorOp &) const
template<typename IterT , typename VisitorOp >
void | visit2 (IterT &otherIter, VisitorOp &, bool otherIsLHS=false)
template<typename IterT , typename VisitorOp >
void | visit2 (IterT &otherIter, VisitorOp &, bool otherIsLHS=false) const
void | addTile (Index level, const Coord &, const ValueType &, bool)
void | addTile (Index offset, const ValueType &, bool)
template<typename AccessorT >
void | addTileAndCache (Index, const Coord &, const ValueType &, bool, AccessorT &)
bool | isConstant (ValueType &constValue, bool &state, const ValueType &tolerance=zeroVal< ValueType >()) const
bool | isConstant (ValueType &minValue, ValueType &maxValue, bool &state, const ValueType &tolerance=zeroVal< ValueType >()) const
bool | isInactive () const
| Return `true` if all of this node's values are inactive. More...
bool | isValueMaskOn (Index n) const
bool | isValueMaskOn () const
bool | isValueMaskOff (Index n) const
bool | isValueMaskOff () const
const NodeMaskType & | getValueMask () const
NodeMaskType & | getValueMask ()
void | setValueMask (const NodeMaskType &mask)
bool | isChildMaskOn (Index) const
bool | isChildMaskOff (Index) const
bool | isChildMaskOff () const
PointIndexLeafNode * | touchLeaf (const Coord &)
| Return a pointer to this node. More...
template<typename AccessorT >
PointIndexLeafNode * | touchLeafAndCache (const Coord &, AccessorT &)
| Return a pointer to this node. More...
template<typename NodeT , typename AccessorT >
NodeT * | probeNodeAndCache (const Coord &, AccessorT &)
| Return a pointer to this node. More...
PointIndexLeafNode * | probeLeaf (const Coord &)
| Return a pointer to this node. More...
template<typename AccessorT >
PointIndexLeafNode * | probeLeafAndCache (const Coord &, AccessorT &)
| Return a pointer to this node. More...
const PointIndexLeafNode * | probeConstLeaf (const Coord &) const
| Return a `const` pointer to this node. More...
template<typename AccessorT >
const PointIndexLeafNode * | probeConstLeafAndCache (const Coord &, AccessorT &) const
| Return a `const` pointer to this node. More...
template<typename AccessorT >
const PointIndexLeafNode * | probeLeafAndCache (const Coord &, AccessorT &) const
| Return a `const` pointer to this node. More...
const PointIndexLeafNode * | probeLeaf (const Coord &) const
| Return a `const` pointer to this node. More...
template<typename NodeT , typename AccessorT >
const NodeT * | probeConstNodeAndCache (const Coord &, AccessorT &) const
| Return a `const` pointer to this node. More...
const Coord & | origin () const
| Return the grid index coordinates of this node's local origin. More...
void | getOrigin (Coord &origin) const
| Return the grid index coordinates of this node's local origin. More...
void | getOrigin (Int32 &x, Int32 &y, Int32 &z) const
| Return the grid index coordinates of this node's local origin. More...
void | prune (const ValueType &=zeroVal< ValueType >())
| This function exists only to enable template instantiation. More...
void | addLeaf (LeafNode *)
| This function exists only to enable template instantiation. More...
template<typename AccessorT >
void | addLeafAndCache (LeafNode *, AccessorT &)
| This function exists only to enable template instantiation. More...
template<typename NodeT >
NodeT * | stealNode (const Coord &, const ValueType &, bool)
| This function exists only to enable template instantiation. More...
template<typename NodeT >
NodeT * | probeNode (const Coord &)
| This function exists only to enable template instantiation. More...
template<typename NodeT >
const NodeT * | probeConstNode (const Coord &) const
| This function exists only to enable template instantiation. More...
template<typename ArrayT >
void | getNodes (ArrayT &) const
| This function exists only to enable template instantiation. More...
template<typename ArrayT >
void | stealNodes (ArrayT &, const ValueType &, bool)
| This function exists only to enable template instantiation. More...

## Static Public Member Functions
static Index | log2dim ()
| Return log2 of the dimension of this LeafNode, e.g. 3 if dimensions are 8^3. More...
static Index | dim ()
| Return the number of voxels in each coordinate dimension. More...
static Index | size ()
| Return the total number of voxels represented by this LeafNode. More...
static Index | numValues ()
| Return the total number of voxels represented by this LeafNode. More...
static Index | getLevel ()
| Return the level of this node, which by definition is zero for LeafNodes. More...
static void | getNodeLog2Dims (std::vector< Index > &dims)
| Append the Log2Dim of this LeafNode to the specified vector. More...
static Index | getChildDim ()
| Return the dimension of child nodes of this LeafNode, which is one for voxels. More...
static Index32 | leafCount ()
| Return the leaf count for this node, which is one. More...
static Index32 | nonLeafCount ()
| Return the non-leaf count for this node, which is zero. More...
static Index64 | onTileCount ()
static Index64 | offTileCount ()
static Index | coordToOffset (const Coord &xyz)
| Return the linear table offset of the given global or local coordinates. More...
static Coord | offsetToLocalCoord (Index n)
| Return the local coordinates for a linear table offset, where offset 0 has coordinates (0, 0, 0). More...
static Index | getValueLevel (const Coord &)
| Return the level (i.e., 0) at which leaf node values reside. More...
static bool | hasActiveTiles ()
| Return `false` since leaf nodes never contain tiles. More...
template<typename AccessorT >
static Index | getValueLevelAndCache (const Coord &, AccessorT &)
| Return the LEVEL (=0) at which leaf node values reside. More...

## Static Public Attributes
static const Index | LOG2DIM = Log2Dim
static const Index | TOTAL = Log2Dim
static const Index | DIM = 1 << TOTAL
static const Index | NUM_VALUES = 1 << 3 * Log2Dim
static const Index | NUM_VOXELS = NUM_VALUES
static const Index | SIZE = NUM_VALUES
static const Index | LEVEL = 0

## Protected Types
typedef BaseLeaf::ValueOn | ValueOn
typedef BaseLeaf::ValueOff | ValueOff
typedef BaseLeaf::ValueAll | ValueAll
typedef BaseLeaf::ChildOn | ChildOn
typedef BaseLeaf::ChildOff | ChildOff
typedef BaseLeaf::ChildAll | ChildAll
typedef NodeMaskType::OnIterator | MaskOnIterator
typedef NodeMaskType::OffIterator | MaskOffIterator
typedef NodeMaskType::DenseIterator | MaskDenseIterator

## Protected Member Functions
void | setValueMask (Index n, bool on)
void | setValueMaskOn (Index n)
void | setValueMaskOff (Index n)

## Static Protected Member Functions
static void | evalNodeOrigin (Coord &xyz)
| Compute the origin of the leaf node that contains the voxel with the given coordinates. More...
template<typename NodeT , typename VisitorOp , typename ChildAllIterT >
static void | doVisit (NodeT &, VisitorOp &)
template<typename NodeT , typename OtherNodeT , typename VisitorOp , typename ChildAllIterT , typename OtherChildAllIterT >
static void | doVisit2Node (NodeT &self, OtherNodeT &other, VisitorOp &)
template<typename NodeT , typename VisitorOp , typename ChildAllIterT , typename OtherChildAllIterT >
static void | doVisit2 (NodeT &self, OtherChildAllIterT &, VisitorOp &, bool otherIsLHS)

## Friends
template<typename , Index >
struct | PointIndexLeafNode
class | tree::IteratorBase< MaskOnIterator, PointIndexLeafNode >
class | tree::IteratorBase< MaskOffIterator, PointIndexLeafNode >
class | tree::IteratorBase< MaskDenseIterator, PointIndexLeafNode >

## Member Typedef Documentation

typedef tree::LeafNode<T, Log2Dim> BaseLeaf

typedef BaseLeaf::ChildAll ChildAll
| protected

typedef BaseLeaf::template DenseIter< const PointIndexLeafNode, const ValueType, ChildAll> ChildAllCIter

typedef BaseLeaf::template DenseIter< PointIndexLeafNode, ValueType, ChildAll> ChildAllIter

typedef BaseLeaf::ChildOff ChildOff
| protected

typedef BaseLeaf::template ChildIter< MaskOffIterator, const PointIndexLeafNode, ChildOff> ChildOffCIter

typedef BaseLeaf::template ChildIter< MaskOffIterator, PointIndexLeafNode, ChildOff> ChildOffIter

typedef BaseLeaf::ChildOn ChildOn
| protected

typedef BaseLeaf::template ChildIter< MaskOnIterator, const PointIndexLeafNode, ChildOn> ChildOnCIter

typedef BaseLeaf::template ChildIter< MaskOnIterator, PointIndexLeafNode, ChildOn> ChildOnIter

typedef std::vector<ValueType> IndexArray

typedef PointIndexLeafNode<T, Log2Dim> LeafNodeType

typedef NodeMaskType::DenseIterator MaskDenseIterator
| protected

typedef NodeMaskType::OffIterator MaskOffIterator
| protected

typedef NodeMaskType::OnIterator MaskOnIterator
| protected

typedef util::NodeMask<Log2Dim> NodeMaskType

typedef boost::shared_ptr<PointIndexLeafNode> Ptr

typedef BaseLeaf::ValueAll ValueAll
| protected

typedef BaseLeaf::template ValueIter< MaskDenseIterator,const PointIndexLeafNode,const ValueType,ValueAll> ValueAllCIter

typedef BaseLeaf::template ValueIter< MaskDenseIterator, PointIndexLeafNode, const ValueType, ValueAll> ValueAllIter

typedef BaseLeaf::ValueOff ValueOff
| protected

typedef BaseLeaf::template ValueIter< MaskOffIterator,const PointIndexLeafNode,const ValueType,ValueOff> ValueOffCIter

typedef BaseLeaf::template ValueIter< MaskOffIterator, PointIndexLeafNode, const ValueType, ValueOff> ValueOffIter

typedef BaseLeaf::ValueOn ValueOn
| protected

typedef BaseLeaf::template ValueIter< MaskOnIterator, const PointIndexLeafNode, const ValueType, ValueOn> ValueOnCIter

typedef BaseLeaf::template ValueIter< MaskOnIterator, PointIndexLeafNode, const ValueType, ValueOn> ValueOnIter

typedef T ValueType

## Constructor & Destructor Documentation

PointIndexLeafNode | ( |  | ) |
| inline

Default constructor.

PointIndexLeafNode | ( | const Coord & | coords,
|  | const T & | value = `zeroVal<T>()`,
|  | bool | active = `false`
| ) |  |
| inlineexplicit

PointIndexLeafNode | ( | PartialCreate | ,
|  | const Coord & | coords,
|  | const T & | value = `zeroVal<T>()`,
|  | bool | active = `false`
| ) |  |
| inline

PointIndexLeafNode | ( | const PointIndexLeafNode< T, Log2Dim > & | rhs | ) |
| inline

Deep copy constructor.

## Member Function Documentation

void addLeaf | ( | LeafNode< T, Log2Dim > * |  | ) |
| inlineinherited

This function exists only to enable template instantiation.

void addLeaf | ( | PointIndexLeafNode< T, Log2Dim > * |  | ) |
| inline

void addLeafAndCache | ( | LeafNode< T, Log2Dim > * | ,
|  | AccessorT & |
| ) |  |
| inlineinherited

This function exists only to enable template instantiation.

void addLeafAndCache | ( | PointIndexLeafNode< T, Log2Dim > * | ,
|  | AccessorT & |
| ) |  |
| inline

void addTile | ( | Index | level,
|  | const Coord & | xyz,
|  | const ValueType & | val,
|  | bool | active
| ) |  |
| inlineinherited

void addTile | ( | Index | offset,
|  | const ValueType & | val,
|  | bool | active
| ) |  |
| inlineinherited

void addTileAndCache | ( | Index | level,
|  | const Coord & | xyz,
|  | const ValueType & | val,
|  | bool | active,
|  | AccessorT & |
| ) |  |
| inlineinherited

bool allocate | ( |  | ) |
| inlineinherited

Allocate memory for this node's buffer if it has not already been allocated.

void assertNonmodifiable | ( |  | ) |
| inline

ChildAllCIter beginChildAll | ( |  | ) | const
| inline

ChildAllIter beginChildAll | ( |  | ) |
| inline

ChildOffCIter beginChildOff | ( |  | ) | const
| inline

ChildOffIter beginChildOff | ( |  | ) |
| inline

ChildOnCIter beginChildOn | ( |  | ) | const
| inline

ChildOnIter beginChildOn | ( |  | ) |
| inline

ValueAllCIter beginValueAll | ( |  | ) | const
| inline

ValueAllIter beginValueAll | ( |  | ) |
| inline

ValueOffCIter beginValueOff | ( |  | ) | const
| inline

ValueOffIter beginValueOff | ( |  | ) |
| inline

ValueOnCIter beginValueOn | ( |  | ) | const
| inline

ValueOnIter beginValueOn | ( |  | ) |
| inline

const Buffer& buffer | ( |  | ) | const
| inlineinherited

Buffer& buffer | ( |  | ) |
| inlineinherited

ChildAllCIter cbeginChildAll | ( |  | ) | const
| inline

ChildOffCIter cbeginChildOff | ( |  | ) | const
| inline

ChildOnCIter cbeginChildOn | ( |  | ) | const
| inline

ValueAllCIter cbeginValueAll | ( |  | ) | const
| inline

ValueOffCIter cbeginValueOff | ( |  | ) | const
| inline

ValueOnCIter cbeginValueOn | ( |  | ) | const
| inline

ChildAllCIter cendChildAll | ( |  | ) | const
| inline

ChildOffCIter cendChildOff | ( |  | ) | const
| inline

ChildOnCIter cendChildOn | ( |  | ) | const
| inline

ValueAllCIter cendValueAll | ( |  | ) | const
| inline

ValueOffCIter cendValueOff | ( |  | ) | const
| inline

ValueOnCIter cendValueOn | ( |  | ) | const
| inline

void clip | ( | const CoordBBox & | ,
|  | const ValueType & |
| ) |  |
| inline

void combine | ( | const LeafNode< T, Log2Dim > & | other,
|  | CombineOp & | op
| ) |  |
| inlineinherited

void combine | ( | const ValueType & | value,
|  | bool | valueIsActive,
|  | CombineOp & | op
| ) |  |
| inlineinherited

void combine2 | ( | const LeafNode< T, Log2Dim > & | other,
|  | const OtherType & | value,
|  | bool | valueIsActive,
|  | CombineOp & | op
| ) |  |
| inlineinherited

void combine2 | ( | const ValueType & | value,
|  | const OtherNodeT & | other,
|  | bool | valueIsActive,
|  | CombineOp & | op
| ) |  |
| inlineinherited

void combine2 | ( | const LeafNode< T, Log2Dim > & | b0,
|  | const OtherNodeT & | b1,
|  | CombineOp & | op
| ) |  |
| inlineinherited

Index coordToOffset | ( | const Coord & | xyz | ) |
| inlinestaticinherited

Return the linear table offset of the given global or local coordinates.

void copyFromDense | ( | const CoordBBox & | bbox,
|  | const DenseT & | dense,
|  | const ValueType & | background,
|  | const ValueType & | tolerance
| ) |  |
| inlineinherited

Copy from a dense grid into this node the values of the voxels that lie within a given bounding box.

Only values that are different (by more than the given tolerance) from the background value will be active. Other values are inactive and truncated to the background value.

Parameters

  bbox | inclusive bounding box of the voxels to be copied into this node
  dense | dense grid with a stride in z of one (see tools::Dense in tools/Dense.h for the required API)
  background | background value of the tree that this node belongs to
  tolerance | tolerance within which a value equals the background value

Note
  bbox is assumed to be identical to or contained in the coordinate domains of both the dense grid and this node, i.e., no bounds checking is performed.
  Consider using tools::CopyFromDense in tools/Dense.h instead of calling this method directly.

void copyToDense | ( | const CoordBBox & | bbox,
|  | DenseT & | dense
| ) |  | const
| inlineinherited

Copy into a dense grid the values of the voxels that lie within a given bounding box.

Parameters

  bbox | inclusive bounding box of the voxels to be copied into the dense grid
  dense | dense grid with a stride in z of one (see tools::Dense in tools/Dense.h for the required API)

Note
  bbox is assumed to be identical to or contained in the coordinate domains of both the dense grid and this node, i.e., no bounds checking is performed.
  Consider using tools::CopyToDense in tools/Dense.h instead of calling this method directly.

static Index dim | ( |  | ) |
| inlinestaticinherited

Return the number of voxels in each coordinate dimension.

void doVisit | ( | NodeT & | self,
|  | VisitorOp & | op
| ) |  |
| inlinestaticprotectedinherited

void doVisit2 | ( | NodeT & | self,
|  | OtherChildAllIterT & | otherIter,
|  | VisitorOp & | op,
|  | bool | otherIsLHS
| ) |  |
| inlinestaticprotectedinherited

void doVisit2Node | ( | NodeT & | self,
|  | OtherNodeT & | other,
|  | VisitorOp & | op
| ) |  |
| inlinestaticprotectedinherited

ChildAllCIter endChildAll | ( |  | ) | const
| inline

ChildAllIter endChildAll | ( |  | ) |
| inline

ChildOffCIter endChildOff | ( |  | ) | const
| inline

ChildOffIter endChildOff | ( |  | ) |
| inline

ChildOnCIter endChildOn | ( |  | ) | const
| inline

ChildOnIter endChildOn | ( |  | ) |
| inline

ValueAllCIter endValueAll | ( |  | ) | const
| inline

ValueAllIter endValueAll | ( |  | ) |
| inline

ValueOffCIter endValueOff | ( |  | ) | const
| inline

ValueOffIter endValueOff | ( |  | ) |
| inline

ValueOnCIter endValueOn | ( |  | ) | const
| inline

ValueOnIter endValueOn | ( |  | ) |
| inline

void evalActiveBoundingBox | ( | CoordBBox & | bbox,
|  | bool | visitVoxels = `true`
| ) |  | const
| inlineinherited

Expand the given bounding box so that it includes this leaf node's active voxels. If visitVoxels is false this LeafNode will be approximated as dense, i.e. with all voxels active. Else the individual active voxels are visited to produce a tight bbox.

static void evalNodeOrigin | ( | Coord & | xyz | ) |
| inlinestaticprotectedinherited

Compute the origin of the leaf node that contains the voxel with the given coordinates.

void fill | ( | const CoordBBox & | ,
|  | const ValueType & | ,
|  | bool |
| ) |  |
| inline

void fill | ( | const ValueType & |  | ) |
| inline

void fill | ( | const ValueType & | ,
|  | bool |
| ) |  |
| inline

static Index getChildDim | ( |  | ) |
| inlinestaticinherited

Return the dimension of child nodes of this LeafNode, which is one for voxels.

const ValueType& getFirstValue | ( |  | ) | const
| inlineinherited

Return a const reference to the first value in the buffer.

Note
  Though it is potentially risky you can convert this to a non-const pointer by means of const_case<ValueType*>&.

bool getIndices | ( | const Coord & | ijk,
|  | const ValueType *& | begin,
|  | const ValueType *& | end
| ) |  | const
| inline

bool getIndices | ( | Index | offset,
|  | const ValueType *& | begin,
|  | const ValueType *& | end
| ) |  | const
| inline

const ValueType& getLastValue | ( |  | ) | const
| inlineinherited

Return a const reference to the last value in the buffer.

static Index getLevel | ( |  | ) |
| inlinestaticinherited

Return the level of this node, which by definition is zero for LeafNodes.

CoordBBox getNodeBoundingBox | ( |  | ) | const
| inlineinherited

Return the bounding box of this node, i.e., the full index space spanned by this leaf node.

static void getNodeLog2Dims | ( | std::vector< Index > & | dims | ) |
| inlinestaticinherited

Append the Log2Dim of this LeafNode to the specified vector.

void getNodes | ( | ArrayT & |  | ) | const
| inlineinherited

This function exists only to enable template instantiation.

void getOrigin | ( | Coord & | origin | ) | const
| inlineinherited

Return the grid index coordinates of this node's local origin.

void getOrigin | ( | Int32 & | x,
|  | Int32 & | y,
|  | Int32 & | z
| ) |  | const
| inlineinherited

Return the grid index coordinates of this node's local origin.

const ValueT & getValue | ( | const Coord & | xyz | ) | const
| inlineinherited

Return the value of the voxel at the given coordinates.

const ValueT & getValue | ( | Index | offset | ) | const
| inlineinherited

Return the value of the voxel at the given linear offset.

const ValueType& getValue | ( | const Coord & | xyz,
|  | bool & | state,
|  | int & | level,
|  | AccessorT & |
| ) |  | const
| inlineinherited

Return the value of the voxel at the given coordinates and return its active state and level (i.e., 0) in state and level.

Note
  Used internally by ValueAccessor.

const ValueType& getValueAndCache | ( | const Coord & | xyz,
|  | AccessorT & |
| ) |  | const
| inlineinherited

Return the value of the voxel at the given coordinates.

Note
  Used internally by ValueAccessor.

static Index getValueLevel | ( | const Coord & |  | ) |
| inlinestaticinherited

Return the level (i.e., 0) at which leaf node values reside.

static Index getValueLevelAndCache | ( | const Coord & | ,
|  | AccessorT & |
| ) |  |
| inlinestaticinherited

Return the LEVEL (=0) at which leaf node values reside.

Note
  Used internally by ValueAccessor (note last argument is a dummy).

const NodeMaskType& getValueMask | ( |  | ) | const
| inlineinherited

NodeMaskType& getValueMask | ( |  | ) |
| inlineinherited

static bool hasActiveTiles | ( |  | ) |
| inlinestaticinherited

Return `false` since leaf nodes never contain tiles.

bool hasSameTopology | ( | const LeafNode< OtherType, OtherLog2Dim > * | other | ) | const
| inlineinherited

Return `true` if the given node (which may have a different `ValueType` than this node) has the same active value topology as this node.

bool hasSameTopology | ( | const PointIndexLeafNode< OtherType, OtherLog2Dim > * | other | ) | const
| inline

Return `true` if the given node (which may have a different `ValueType` than this node) has the same active value topology as this node.

IndexArray& indices | ( |  | ) |
| inline

const IndexArray& indices | ( |  | ) | const
| inline

bool isAllocated | ( |  | ) | const
| inlineinherited

Return `true` if memory for this node's buffer has been allocated.

bool isChildMaskOff | ( | Index |  | ) | const
| inlineinherited

bool isChildMaskOff | ( |  | ) | const
| inlineinherited

bool isChildMaskOn | ( | Index |  | ) | const
| inlineinherited

bool isConstant | ( | ValueType & | constValue,
|  | bool & | state,
|  | const ValueType & | tolerance = `zeroVal<ValueType>()`
| ) |  | const
| inlineinherited

Return `true` if all of this node's values have the same active state and are in the range this->getFirstValue() +/- tolerance.

Parameters

  constValue | Is updated with the first value of this leaf node.
  state | Is updated with the state of all values IF method returns `true`. Else the value is undefined!
  tolerance | The tolerance used to determine if values are approximatly equal to the for value.

bool isConstant | ( | ValueType & | minValue,
|  | ValueType & | maxValue,
|  | bool & | state,
|  | const ValueType & | tolerance = `zeroVal<ValueType>()`
| ) |  | const
| inlineinherited

Return `true` if all of this node's values have the same active state and are in the range (maxValue + minValue)/2 +/- tolerance.

Parameters

  minValue | Is updated with the minimum of all values IF method returns `true`. Else the value is undefined!
  maxValue | Is updated with the maximum of all values IF method returns `true`. Else the value is undefined!
  state | Is updated with the state of all values IF method returns `true`. Else the value is undefined!
  tolerance | The tolerance used to determine if values are approximatly constant.

bool isDense | ( |  | ) | const
| inlineinherited

Return `true` if this node contains only active voxels.

bool isEmpty | ( |  | ) | const
| inlineinherited

Return `true` if this node has no active voxels.

bool isEmpty | ( | const CoordBBox & | bbox | ) | const
| inline

bool isInactive | ( |  | ) | const
| inlineinherited

Return `true` if all of this node's values are inactive.

bool isValueMaskOff | ( | Index | n | ) | const
| inlineinherited

bool isValueMaskOff | ( |  | ) | const
| inlineinherited

bool isValueMaskOn | ( | Index | n | ) | const
| inlineinherited

bool isValueMaskOn | ( |  | ) | const
| inlineinherited

bool isValueOn | ( | const Coord & | xyz | ) | const
| inlineinherited

Return `true` if the voxel at the given coordinates is active.

bool isValueOn | ( | Index | offset | ) | const
| inlineinherited

Return `true` if the voxel at the given offset is active.

bool isValueOnAndCache | ( | const Coord & | xyz,
|  | AccessorT & |
| ) |  | const
| inlineinherited

Return `true` if the voxel at the given coordinates is active.

Note
  Used internally by ValueAccessor.

static Index32 leafCount | ( |  | ) |
| inlinestaticinherited

Return the leaf count for this node, which is one.

static Index log2dim | ( |  | ) |
| inlinestaticinherited

Return log2 of the dimension of this LeafNode, e.g. 3 if dimensions are 8^3.

Index64 memUsage | ( |  | ) | const
| inline

void merge | ( | const LeafNode< T, Log2Dim > & | other | ) |
| inlineinherited

void merge | ( | const LeafNode< T, Log2Dim > & | other,
|  | const ValueType & | ,
|  | const ValueType & |
| ) |  |
| inlineinherited

void merge | ( | const PointIndexLeafNode< T, Log2Dim > & | rhs | ) |
| inline

void merge | ( | const ValueType & | tileValue,
|  | bool | tileActive
| ) |  |
| inline

void merge | ( | const PointIndexLeafNode< T, Log2Dim > & | other,
|  | const ValueType & | ,
|  | const ValueType & |
| ) |  |
| inline

void modifyValue | ( | Index | ,
|  | const ModifyOp & |
| ) |  |
| inline

void modifyValue | ( | const Coord & | ,
|  | const ModifyOp & |
| ) |  |
| inline

void modifyValueAndActiveState | ( | const Coord & | ,
|  | const ModifyOp & |
| ) |  |
| inline

void modifyValueAndActiveStateAndCache | ( | const Coord & | ,
|  | const ModifyOp & | ,
|  | AccessorT & |
| ) |  |
| inline

void modifyValueAndCache | ( | const Coord & | xyz,
|  | const ModifyOp & | op,
|  | AccessorT & |
| ) |  |
| inlineinherited

Apply a functor to the value of the voxel at the given coordinates and mark the voxel as active.

Note
  Used internally by ValueAccessor.

void negate | ( |  | ) |
| inline

static Index32 nonLeafCount | ( |  | ) |
| inlinestaticinherited

Return the non-leaf count for this node, which is zero.

static Index numValues | ( |  | ) |
| inlinestaticinherited

Return the total number of voxels represented by this LeafNode.

Index64 offLeafVoxelCount | ( |  | ) | const
| inlineinherited

Coord offsetToGlobalCoord | ( | Index | n | ) | const
| inlineinherited

Return the global coordinates for a linear table offset.

Coord offsetToLocalCoord | ( | Index | n | ) |
| inlinestaticinherited

Return the local coordinates for a linear table offset, where offset 0 has coordinates (0, 0, 0).

static Index64 offTileCount | ( |  | ) |
| inlinestaticinherited

Index64 offVoxelCount | ( |  | ) | const
| inlineinherited

Return the number of voxels marked Off.

Index64 onLeafVoxelCount | ( |  | ) | const
| inlineinherited

static Index64 onTileCount | ( |  | ) |
| inlinestaticinherited

Index64 onVoxelCount | ( |  | ) | const
| inlineinherited

Return the number of voxels marked On.

bool operator!= | ( | const LeafNode< T, Log2Dim > & | other | ) | const
| inlineinherited

bool operator!= | ( | const PointIndexLeafNode< T, Log2Dim > & | other | ) | const
| inline

bool operator== | ( | const LeafNode< T, Log2Dim > & | other | ) | const
| inlineinherited

Check for buffer, state and origin equivalence.

bool operator== | ( | const PointIndexLeafNode< T, Log2Dim > & | other | ) | const
| inline

Check for buffer, state and origin equivalence.

const Coord& origin | ( |  | ) | const
| inlineinherited

Return the grid index coordinates of this node's local origin.

const PointIndexLeafNode* probeConstLeaf | ( | const Coord & |  | ) | const
| inline

Return a `const` pointer to this node.

const PointIndexLeafNode* probeConstLeafAndCache | ( | const Coord & | ,
|  | AccessorT & |
| ) |  | const
| inline

Return a `const` pointer to this node.

const NodeT* probeConstNode | ( | const Coord & |  | ) | const
| inlineinherited

This function exists only to enable template instantiation.

const NodeT* probeConstNodeAndCache | ( | const Coord & | ,
|  | AccessorT & |
| ) |  | const
| inline

Return a `const` pointer to this node.

PointIndexLeafNode* probeLeaf | ( | const Coord & |  | ) |
| inline

Return a pointer to this node.

const PointIndexLeafNode* probeLeaf | ( | const Coord & |  | ) | const
| inline

Return a `const` pointer to this node.

PointIndexLeafNode* probeLeafAndCache | ( | const Coord & | ,
|  | AccessorT & |
| ) |  |
| inline

Return a pointer to this node.

const PointIndexLeafNode* probeLeafAndCache | ( | const Coord & | ,
|  | AccessorT & |
| ) |  | const
| inline

Return a `const` pointer to this node.

NodeT* probeNode | ( | const Coord & |  | ) |
| inlineinherited

This function exists only to enable template instantiation.

NodeT* probeNodeAndCache | ( | const Coord & | ,
|  | AccessorT & |
| ) |  |
| inline

Return a pointer to this node.

bool probeValue | ( | const Coord & | xyz,
|  | ValueType & | val
| ) |  | const
| inlineinherited

Return `true` if the voxel at the given coordinates is active.

Parameters

  | xyz | the coordinates of the voxel to be probed
  [out] | val | the value of the voxel at the given coordinates

bool probeValue | ( | Index | offset,
|  | ValueType & | val
| ) |  | const
| inlineinherited

Return `true` if the voxel at the given offset is active.

Parameters

  | offset | the linear offset of the voxel to be probed
  [out] | val | the value of the voxel at the given coordinates

bool probeValueAndCache | ( | const Coord & | xyz,
|  | ValueType & | val,
|  | AccessorT & |
| ) |  | const
| inlineinherited

Return `true` if the voxel at the given coordinates is active and return the voxel value in val.

Note
  Used internally by ValueAccessor.

void prune | ( | const ValueType & | = `zeroVal<ValueType>()` | ) |
| inlineinherited

This function exists only to enable template instantiation.

void readBuffers | ( | std::istream & | is,
|  | bool | fromHalf = `false`
| ) |  |
| inline

void readBuffers | ( | std::istream & | is,
|  | const CoordBBox & | bbox,
|  | bool | fromHalf = `false`
| ) |  |
| inline

void readTopology | ( | std::istream & | is,
|  | bool | fromHalf = `false`
| ) |  |
| inlineinherited

Read in just the topology.

Parameters

  is | the stream from which to read
  fromHalf | if true, floating-point input values are assumed to be 16-bit

void resetBackground | ( | const ValueType & | ,
|  | const ValueType & |
| ) |  |
| inline

void setActiveState | ( | const Coord & | ,
|  | bool |
| ) |  |
| inline

void setActiveState | ( | Index | ,
|  | bool |
| ) |  |
| inline

void setActiveStateAndCache | ( | const Coord & | ,
|  | bool | ,
|  | AccessorT & |
| ) |  |
| inline

void setOffsetOn | ( | Index | offset,
|  | const ValueType & | val
| ) |  |
| inline

void setOffsetOnly | ( | Index | offset,
|  | const ValueType & | val
| ) |  |
| inline

void setOrigin | ( | const Coord & | origin | ) |
| inlineinherited

Set the grid index coordinates of this node's local origin.

void setValue | ( | const Coord & | ,
|  | const ValueType & |
| ) |  |
| inline

void setValueAndCache | ( | const Coord & | xyz,
|  | const ValueType & | val,
|  | AccessorT & |
| ) |  |
| inlineinherited

Change the value of the voxel at the given coordinates and mark it as active.

Note
  Used internally by ValueAccessor.

void setValueMask | ( | const NodeMaskType & | mask | ) |
| inlineinherited

void setValueMask | ( | Index | n,
|  | bool | on
| ) |  |
| inlineprotectedinherited

void setValueMaskOff | ( | Index | n | ) |
| inlineprotectedinherited

void setValueMaskOn | ( | Index | n | ) |
| inlineprotectedinherited

void setValueOff | ( | const Coord & |  | ) |
| inline

void setValueOff | ( | Index |  | ) |
| inline

void setValueOff | ( | const Coord & | ,
|  | const ValueType & |
| ) |  |
| inline

void setValueOff | ( | Index | ,
|  | const ValueType & |
| ) |  |
| inline

void setValueOffAndCache | ( | const Coord & | ,
|  | const ValueType & | ,
|  | AccessorT & |
| ) |  |
| inline

void setValueOn | ( | const Coord & |  | ) |
| inline

void setValueOn | ( | Index |  | ) |
| inline

void setValueOn | ( | const Coord & | ,
|  | const ValueType & |
| ) |  |
| inline

void setValueOn | ( | Index | ,
|  | const ValueType & |
| ) |  |
| inline

void setValueOnly | ( | const Coord & | ,
|  | const ValueType & |
| ) |  |
| inline

void setValueOnly | ( | Index | ,
|  | const ValueType & |
| ) |  |
| inline

void setValueOnlyAndCache | ( | const Coord & | ,
|  | const ValueType & | ,
|  | AccessorT & |
| ) |  |
| inline

void setValuesOff | ( |  | ) |
| inline

void setValuesOn | ( |  | ) |
| inline

void signedFloodFill | ( | const ValueType & |  | ) |
| inline

void signedFloodFill | ( | const ValueType & | ,
|  | const ValueType & |
| ) |  |
| inline

static Index size | ( |  | ) |
| inlinestaticinherited

Return the total number of voxels represented by this LeafNode.

NodeT* stealNode | ( | const Coord & | ,
|  | const ValueType & | ,
|  | bool |
| ) |  |
| inlineinherited

This function exists only to enable template instantiation.

void stealNodes | ( | ArrayT & | ,
|  | const ValueType & | ,
|  | bool |
| ) |  |
| inlineinherited

This function exists only to enable template instantiation.

std::string str | ( |  | ) | const
| inlineinherited

Return a string representation of this node.

size_t streamingSize | ( | bool | toHalf = `false` | ) | const
| inherited

void swap | ( | Buffer & | other | ) |
| inlineinherited

Exchange this node's data buffer with the given data buffer without changing the active states of the values.

void topologyDifference | ( | const LeafNode< OtherType, Log2Dim > & | other,
|  | const ValueType & |
| ) |  |
| inlineinherited

Difference this node's set of active values with the active values of the other node, whose `ValueType` may be different. So a resulting voxel will be active only if the original voxel is active in this LeafNode and inactive in the other LeafNode.

The last dummy argument is required to match the signature for InternalNode::topologyDifference.

Note
  This operation modifies only active states, not values. Also, because it can deactivate all of this node's voxels, consider subsequently calling prune.

void topologyIntersection | ( | const LeafNode< OtherType, Log2Dim > & | other,
|  | const ValueType & |
| ) |  |
| inlineinherited

Intersect this node's set of active values with the active values of the other node, whose `ValueType` may be different. So a resulting voxel will be active only if both of the original voxels were active.

The last dummy argument is required to match the signature for InternalNode::topologyIntersection.

Note
  This operation modifies only active states, not values. Also note that this operation can result in all voxels being inactive so consider subsequnetly calling prune.

void topologyUnion | ( | const LeafNode< OtherType, Log2Dim > & | other | ) |
| inlineinherited

Union this node's set of active values with the active values of the other node, whose `ValueType` may be different. So a resulting voxel will be active if either of the original voxels were active.

Note
  This operation modifies only active states, not values.

PointIndexLeafNode* touchLeaf | ( | const Coord & |  | ) |
| inline

Return a pointer to this node.

PointIndexLeafNode* touchLeafAndCache | ( | const Coord & | ,
|  | AccessorT & |
| ) |  |
| inline

Return a pointer to this node.

void visit | ( | VisitorOp & | op | ) |
| inlineinherited

void visit | ( | VisitorOp & | op | ) | const
| inlineinherited

void visit2 | ( | IterT & | otherIter,
|  | VisitorOp & | op,
|  | bool | otherIsLHS = `false`
| ) |  |
| inlineinherited

void visit2 | ( | IterT & | otherIter,
|  | VisitorOp & | op,
|  | bool | otherIsLHS = `false`
| ) |  | const
| inlineinherited

void visit2Node | ( | OtherLeafNodeType & | other,
|  | VisitorOp & | op
| ) |  |
| inlineinherited

void visit2Node | ( | OtherLeafNodeType & | other,
|  | VisitorOp & | op
| ) |  | const
| inlineinherited

void visitActiveBBox | ( | BBoxOp & | op | ) | const
| inlineinherited

Calls the templated functor BBoxOp with bounding box information. An additional level argument is provided to the callback.

Note
  The bounding boxes are guarenteed to be non-overlapping.

void voxelizeActiveTiles | ( |  | ) |
| inlineinherited

void writeBuffers | ( | std::ostream & | os,
|  | bool | toHalf = `false`
| ) |  | const
| inline

void writeTopology | ( | std::ostream & | os,
|  | bool | toHalf = `false`
| ) |  | const
| inlineinherited

Write out just the topology.

Parameters

  os | the stream to which to write
  toHalf | if true, output floating-point values as 16-bit half floats

## Friends And Related Function Documentation

friend struct PointIndexLeafNode
| friend

friend class tree::IteratorBase< MaskDenseIterator, PointIndexLeafNode >
| friend

friend class tree::IteratorBase< MaskOffIterator, PointIndexLeafNode >
| friend

friend class tree::IteratorBase< MaskOnIterator, PointIndexLeafNode >
| friend

## Member Data Documentation

const Index DIM = 1 << TOTAL
| staticinherited

const Index LEVEL = 0
| staticinherited

const Index LOG2DIM = Log2Dim
| staticinherited

const Index NUM_VALUES = 1 << 3 * Log2Dim
| staticinherited

const Index NUM_VOXELS = NUM_VALUES
| staticinherited

const Index SIZE = NUM_VALUES
| staticinherited

const Index TOTAL = Log2Dim
| staticinherited

The documentation for this struct was generated from the following file:

- PointIndexGrid.h